const showMessage = (m, s) => {
	s = s == undefined ? true : s;
	console.log("Copy success (navigator.clipboard)");
	$("body").prepend("<div id='copystatus' style='display: none;'><div class='"+(s ? "succeeded" : "failed")+"'>" + m + "</div></div>");
	$("#copystatus > div").css("top", (window.scrollY + 100)+ "px");
	$("#copystatus").fadeIn(1000, function(){
		$(this).fadeOut( 1000, function() {
			$(this).remove();
		});
	})
}


const copyColourFallback = (copyInfo, attr) => {
	console.log("fallback")
	var textArea = document.createElement('textarea');
	textArea.value = copyInfo;

	// Avoid scrolling to bottom
	textArea.style.top = '0';
	textArea.style.left = '0';
	textArea.style.position = 'fixed';

	document.body.appendChild(textArea);
	textArea.focus();
	textArea.select();

	try {
		var successful = document.execCommand('copy');
		setTimeout(function () {
			if (successful) {
				//copyInfo.success();
				showMessage(`Copied ${attr}.`)
			} else {
				//copyInfo.error();
				showMessage(`Copy failed (${attr}).`, false)
			}
		}, 1);
	} catch (err) {
		setTimeout(function () {
			showMessage(`Copy failed (${attr}). ${err.Message}`, false);
			
			//copyInfo.error(err);
		}, 1);
	}
	document.body.removeChild(textArea);
}


export const copy = (w, t) => {
	let c = t.parent().attr("data-" + (w=="var" ? "token" : w));
	c = w == "var" ? `var(${c})` : c;

	if (navigator.clipboard) {
		navigator.clipboard.writeText(c).then(function() {
			showMessage(`Copied ${w}.`);
		}, function(e) {
			copyColourFallback(c,w);
		});
	} else {
		copyColourFallback(c, w);
	}
}

export const positionTooltip = () => {
	$("color-pill > span").each(function(){
		if ((Number($("p").css('font-size').replace("px","")) * 10)  > $(this).offset().left) {
			$(this).children("div.tooltip-tc").attr("tip-position", "right");
		} else {
			$(this).children("div.tooltip-tc").attr("tip-position", "bottom");
		}
	})
}

/*
colours.positionTooltip();
$( window ).on("resize", function(){colours.positionTooltip()});
$("name > span, color-pill > span").on("click", function(e){
	e.preventDefault();
	let w = "";
	if (e.metaKey || e.ctrlKey || e.keyCode == 91 || e.keyCode == 224) {
		w = "var";
	} else if (e.altKey) {
		w = "token"
	} else if (e.shiftKey) {
		w = "rgb";
	} else {
		w = "hex";
	}
	copycolor.copy(w, $(this));
});
*/